#pragma once
#include "DataTypeList.h"

// custom data type declarations 

class LSTarType : public LSTypeDefinition
{
public:
	// All data members (retrieving data) should be listed in this enumeration
	enum LSTarTypeMembers
	{
	};
	// All data methods (performing actions on or with the object) should be listed in this enumeration
	enum LSTarTypeMethods
	{
		Open,
	};

	LSTarType() : LSType("tar")
	{
		TypeMethod(Open);
	}

	virtual bool GetMember(LSOBJECTDATA ObjectData, PLSTYPEMEMBER pMember, int argc, char *argv[], LSOBJECT &Object);
	virtual bool GetMethod(LSOBJECTDATA &ObjectData, PLSTYPEMETHOD pMethod, int argc, char *argv[]);
	virtual bool ToText(LSOBJECTDATA ObjectData, char *buf, unsigned int buflen);

    virtual bool InitVariable(LSOBJECTDATA &ObjectData, const char *SubType);
	virtual void FreeVariable(LSOBJECTDATA &ObjectData);

	virtual bool FromText(LSOBJECTDATA &ObjectData, int argc, char *argv[]);
};


class LSGZipType : public LSTypeDefinition
{
public:
	// All data members (retrieving data) should be listed in this enumeration
	enum LSGZipTypeMembers
	{
	};
	// All data methods (performing actions on or with the object) should be listed in this enumeration
	enum LSGZipTypeMethods
	{
		Open,
	};

	LSGZipType() : LSType("gzip")
	{
		TypeMethod(Open);
	}

	virtual bool GetMember(LSOBJECTDATA ObjectData, PLSTYPEMEMBER pMember, int argc, char *argv[], LSOBJECT &Object);
	virtual bool GetMethod(LSOBJECTDATA &ObjectData, PLSTYPEMETHOD pMethod, int argc, char *argv[]);
	virtual bool ToText(LSOBJECTDATA ObjectData, char *buf, unsigned int buflen);

    virtual bool InitVariable(LSOBJECTDATA &ObjectData, const char *SubType);
	virtual void FreeVariable(LSOBJECTDATA &ObjectData);

	virtual bool FromText(LSOBJECTDATA &ObjectData, int argc, char *argv[]);
};
